﻿var widgetAPI = new Common.API.Widget();
var pluginAPI = new Common.API.Plugin();
var tvKey = new Common.API.TVKeyValue();
var Main = {
	selected_channel: 0,
	selected_page: 0,
	chan_array_index: 0,
	MODE : -1,
    MainMenu_ID : 0,
    LivePlayer_ID : 1,
	StreamMode : "",
	player : null,
	serieC : false,
	mac_md5 : '',
	hardware : '',
	Selectbox_ID : 2,
	Browser_ID : 3,
	browser_url : '',
	current_href_on_focus_id : 0,
	my_a_hrefs_array : 0,
	my_a_hrefs_length : 0,
	browser_selected_url : '',
	browser_last_selected_url : '',
	document_location_href : '',
	logo : true,
	yandextv_mode : false,
	scrolling : 0,
	VideothekPlayer_ID : 4,
	server_text : '',
	server_text_mode : 0,
	mac_clear : '',
	version : '099'
}

ConsoleLog = function (text) {

		var tm = new Date();
		var h = tm.getHours();
		var m = tm.getMinutes();
		var s = tm.getSeconds();
		var ms = tm.getMilliseconds();
		text = "[" + h + ":" + (m > 10 ? m : ("0" + m)) + ":" + (s > 10 ? s : ("0" + s)) + "," + ms + "] " + text;
		alert(text);
}

ShowDebugOnScreen = function(text)
{

		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(document.getElementById("statusbar"), text);

}

showHandler = function()
{
	NNaviPlugin = document.getElementById("pluginObjectNNavi");
	var test = NNaviPlugin.SetBannerState(2);
	pluginAPI.unregistKey(tvKey.KEY_VOL_UP);
	pluginAPI.unregistKey(tvKey.KEY_VOL_DOWN);
	pluginAPI.unregistKey(tvKey.KEY_MUTE);
}

Main.onLoad = function () 
{
	try
	{
		external_start();
	} catch(e){
		alert("no external func: "+e);
	}	
	window.onShow = showHandler;
	var networkPlugin = document.getElementById("pluginNetwork");
	this.md5_clear = networkPlugin.GetMAC();
	this.mac_md5 = MD5(this.md5_clear);
	try
	{
		ConsoleLog('start');
		
		if(API.init() && Player.init() && Audio.init() && Display.init() && Search.init() && Screen.init() && UrlHelper.init())
		{
			this.MODE = this.MainMenu_ID;	
			API.getChannel_list();
			//alert('getChannel_list');
		}
		
		alert('----------------------------------');
		setInterval ("Main.UpdateTime();", 1000 );
		var tvplug = document.getElementById("pluginTV");
		this.hardware = tvplug.GetProductCode(1);

		if(this.hardware.indexOf("C")>0)
			Main.serieC = true;
	if(API.chan_counter == 0)
	{
		Setup.setFormular();
		Main.LogoStyle();
	}
	/*else
	{	
		//alert('Main.serieC ' + Main.serieC);	
		setTimeout("Main.Starter();", 1000);
	}*/
	}catch(e){
			ShowDebugOnScreen(e);
			alert('error: Main.onLoad ' + e);
			}
	
	
	KeyHandler.create();
	alert('API.chan_counter'  + API.chan_counter);
	setTimeout("Main.LogoStyle();", 1500);
	this.MODE = this.MainMenu_ID;
	Main.updatePage();
	Main.updateChannel();
	Main.setStats();
	Main.newLoader();
	try
	{
		external_end();
	} catch(e){
		alert("no external func: "+e);
	}
	widgetAPI.sendReadyEvent();
}

Main.newLoader = function()
{	
	if(Main.server_text!="")
		Main.serverText();
	alert('Main.server_text_mode: ' + Main.server_text_mode);
	if(Main.server_text_mode==0)//ALL
	{
		Main.activateRemote();
		setTimeout("Display.hidestatus();", 20000);
	}
	if(Main.server_text_mode==1)//BANNED
	{
		widgetAPI.putInnerHTML(document.getElementById("main"), "");
	}
	if(Main.server_text_mode==2)//FREE
	{
		setTimeout("Main.activateRemote();", 30000);
		setTimeout("Display.hidestatus();", 30000);
	}

	//document.getElementById("help_navi_menu").style.display="block";	
}


Main.LogoStyle = function () 
{
	if(Main.logo)
	{
		document.getElementById("logo_bg").style.display="none";
		document.getElementById("leftHalf").style.display="block";
		document.getElementById("rightHalf").style.display="block";
		Main.logo = false;
	}
	alert('ddddddddddddddd');
}


Main.Menu = function()
{
	
	document.getElementById("help_navi_menu").style.display="block";
	document.getElementById("channelList").style.display="";

	try
	{	
		Main.updatePage();
		Main.updateChannel();

		if(Player.state == Player.PLAYING_LIVE || Player.state == Player.PLAYING_VOD)
			document.getElementById("back_to_player").style.display="block";
		else
			document.getElementById("back_to_player").style.display="none";

		KeyHandler.setFocus(this.MainMenu_ID);
	} catch(e){
		alert("Main.Menu ERROR: "+e);
	}	
}

Main.showCategorySelector = function()
{
	KeyHandler.setFocus(Main.Selectbox_ID);
	alert('API.categories ' + API.categories);
	Selectbox.setBox('CATEGORIES', API.categories);
}

Main.showPlaylistSelector = function()
{
	KeyHandler.setFocus(Main.Selectbox_ID);
	Selectbox.setBox('SELECT PLAYLIST', API.PlaylistArray);
}

Main.updatePage = function()
{	

	try
	{
		var chan = Array();
		var time = 0;
		var chan_on_page = 10;

		if(this.selected_page > API.chan_pages-1)
			this.selected_page = 0;
			
		if(this.selected_page < 0)
			this.selected_page = API.chan_pages-1;
		
		for (var index = 0; index < 10; index++)
			{
				document.getElementById("ch"+index).style.display="";
				widgetAPI.putInnerHTML(document.getElementById("time"+index), "");
				widgetAPI.putInnerHTML(document.getElementById("progress"+index), "");
				document.getElementById("percent"+index).style.width= "0%";
				widgetAPI.putInnerHTML(document.getElementById("title"+index), "");
				widgetAPI.putInnerHTML(document.getElementById("descr"+index), "");
				document.getElementById("record"+index).style.backgroundImage= "";
				document.getElementById("descr"+index).style.display="";
				document.getElementById("title"+index).style.width= "250px";
				document.getElementById("number"+index).style = "";
			}
		
		if(this.selected_page == API.chan_pages-1)
		{
			chan_on_page = API.last_page_channels_counter;
			
				for (var index = chan_on_page; index < 10; index++)
				{
					document.getElementById("ch"+index).style.display="none";
				}
				
			if(this.selected_channel > API.last_page_channels_counter-1)
				this.selected_channel = API.last_page_channels_counter-1;
		}

		for (var index = 0; index < chan_on_page; index++)
		{
			
			var chan_array_index = 10*this.selected_page + index;
			
			chan[index] = document.getElementById("chan"+index);
			chan[index].style.backgroundImage= "url(img/menu.png)";

			
			widgetAPI.putInnerHTML(document.getElementById("number"+index), chan_array_index+1);
			var logo = API.channels[chan_array_index][4];
			var logopapka = "logos/"
			if(logo.indexOf(":")>0)
               logopapka = "";
			if(logo!="")
				document.getElementById("img"+index).src=logopapka+logo;
			else
				document.getElementById("img"+index).src="img/dummy.png";
			var title_div = document.getElementById("title"+index);
			widgetAPI.putInnerHTML(title_div, API.channels[chan_array_index][1]);
			var descr_div = document.getElementById("descr"+index);
			if(API.channels[chan_array_index][8])
			{
				var text = '(info)&nbsp;' + API.channels[chan_array_index][8];
				widgetAPI.putInnerHTML(descr_div, text);			
			}
			else
				title_div.style.width = "480px";

		}
	
	} catch(e){
		alert("API.updatePage ERROR: "+e);
		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(Display.statusDiv, '4: ' + e);
	}

}

Main.updateChannel = function()
{
	if(API.chan_counter>0)
	{
		for (var index = 0; index < 10; index++)
		{
			document.getElementById("chan"+index).style.backgroundImage= "url(img/menu.png)";
			document.getElementById("number"+index).style.backgroundImage = "";
		}
		
		this.chan_array_index = 10*this.selected_page + this.selected_channel;

		document.getElementById("number"+this.selected_channel).style.backgroundImage= "url(img/menu_act.png)";
		document.getElementById("chan"+this.selected_channel).style.backgroundImage= "url(img/menu_act.png)";
		
		document.getElementById("yandex").style.display="none";
		this.yandextv_mode = false;
		if(API.channels[this.chan_array_index][6].indexOf('yandex')>-1)
			Main.yandexTVinfo();
		else
			widgetAPI.putInnerHTML(document.getElementById("infoList"), API.channels[this.chan_array_index][6]);
			
		Main.UpdatePlayerStatusbar();
	}

}

Main.yandexTVinfo = function()
{
	this.yandextv_mode = true;
	//this.scrolling = 0;
	var description = API.channels[this.chan_array_index][6].replace("#######",API.yandex_days);
	alert('NEW description: ' + description);
	document.getElementById("yandex").style.display="block";
	widgetAPI.putInnerHTML(document.getElementById("infoList"), description);
	if(this.yandextv_mode)
		setTimeout("Main.yandexTVdisableSelector();",4000);
}

Main.yandexTVdisableSelector = function()
{	
	try
	{
		var b_schedule = document.frames['yandex_tv'].document.getElementsByClassName("b-schedule")[0].innerHTML;
		widgetAPI.putInnerHTML(document.getElementById("infoList"), b_schedule);
	} catch(e){
		alert("yandexTVdisableSelector ERROR: "+e);
	}
}

Main.DisableGone = function()
{
		if(document.getElementsByClassName("gone"))
		{
		className = 'done';
		//document.frames['yandex_tv'].styles.className.display = 'none';
		var test = document.getElementById("infoList");		
		alert('nnnn' + document.getElementsByClassName("gone").innerHTML);
		var gone = document.getElementsByClassName("gone");

		  for(i=0;i<gone.length;i++)
			gone[i].style.display = 'none';	
		}
		
		alert(' test ' + test.innerHTML)
}



Main.selectNextChannel = function()
{

	this.selected_channel++;
	if(this.selected_channel>=10 || (this.selected_page == API.chan_pages-1 && this.selected_channel==API.last_page_channels_counter))
	{
		this.selected_channel = 0;
		this.selected_page++;
		Main.updatePage();
	}

	Main.updateChannel();
}

Main.selectPrevChannel = function()
{

	this.selected_channel--;
	
	if(this.selected_page == 0 && this.selected_channel<0)
	{
		this.selected_channel = API.last_page_channels_counter - 1;
		this.selected_page = API.chan_pages-1;
		Main.updatePage();
	}
	
	if(this.selected_channel<0)
	{
		this.selected_channel = 9;
		this.selected_page--;
		Main.updatePage();
		
	}
	
	Main.updateChannel();
}

Main.selectNextPage = function()
{
	this.selected_page++;
	Main.updatePage();
	Main.updateChannel();
}

Main.selectPrevPage = function()
{

	this.selected_page--;
	Main.updatePage();
	Main.updateChannel();
}

Main.loadPlaylist = function(active_url)
{
	API.active_url = active_url;
	API.getChannel_list();
	KeyHandler.setFocus(Main.MainMenu_ID);
	Main.Menu();	
}
Main.PlayChannel = function()
{	

	var active_url = API.channels[this.chan_array_index][9];
	if(active_url!="")
	{
		Main.loadPlaylist(active_url);	
	}
	else
	{
		try
		{	
			KeyHandler.setFocus(this.LivePlayer_ID);
			Player.selected_channel = this.selected_channel;
			Player.selected_page = this.selected_page;
			
			
			if(API.channels[this.chan_array_index][3]=="flash_rtmp")
			{
				Main.StreamMode = "rtmp";
				Main.PlayFlashStream();
			}
			if(API.channels[this.chan_array_index][3]=="rtmp")
			{
				Main.StreamMode = "rtmp";
				Main.PlayFlashStream();
			}			
			if(API.channels[this.chan_array_index][3]=="flash_flv")
			{
				Main.StreamMode = "flv";
				Main.PlayFlashStream();
			}
			if(API.channels[this.chan_array_index][3]=="hls")
			{
				Main.StreamMode = "hls";
				Main.PlayNoFlashStream();
			}
			if(API.channels[this.chan_array_index][3]=="http")
			{
				Main.StreamMode = "http";
				Main.PlayNoFlashStream();
			}
			if(API.channels[this.chan_array_index][3]=="")
			{
				Main.StreamMode = "http";
				Main.PlayNoFlashStream();
			}
		}
	
	catch(e){
			ShowDebugOnScreen('Main.PlayChannel <br>' + e);
			}
	}
	alert('+++++++Main.StreamMode+++++++' + Main.StreamMode);
}	

		/*
		data = ajaxRequest.responseText ;
var jsonOBJ = eval('(' + data + ')');
len = jsonOBJ.application.length ;
key = jsonOBJ.application[i].optionValue ;
value = jsonOBJ.application[i].optionDisplay ;
		*/
		
Main.PlayNoFlashStream = function()
{	

	delete Main.player;
	document.getElementById("screen_size").style.display="block";
	document.getElementById("flashplayer").style.display="none";
	document.getElementById("main").style.display="block";
	widgetAPI.putInnerHTML(document.getElementById("flashplayer"), "");
				
	widgetAPI.putInnerHTML(document.getElementById("resolution"), '');
	Player.selected_channel = this.selected_channel;
	Player.selected_page = this.selected_page;
	Player.chan_array_index = this.chan_array_index;
	Display.hidemenu();

	var url = API.channels[this.chan_array_index][2];
	if(Main.StreamMode == "hls")
		url = url + "|COMPONENT=HLS";
	alert('url: ' + url);
	url = UrlHelper.parse_url(url);
	Player.setVideoURL(url);
	Player.playVideo();
	Display.showplayer();
}
	
Main.PlayFlashStream = function()
{
	document.getElementById("screen_size").style.display="none";
	Player.stopVideo();
	Player.state = Player.STOPPED;
	if(!Main.serieC)
		Player.state = Player.PLAYING_LIVE;
	
	widgetAPI.putInnerHTML(document.getElementById("resolution"), '');
	
	document.getElementById("main").style.display="none";
	document.getElementById("flashplayer").style.display="block";
	widgetAPI.putInnerHTML(document.getElementById("flashplayer"), "");
	
	var flash_stream_url = UrlHelper.parse_url(API.channels[this.chan_array_index][2]);
	var params = "";
	if(Main.StreamMode == "rtmp")
		params = "file=" + flash_stream_url;

	if(Main.StreamMode == "flv")
		params =  "flv=" + flash_stream_url;

		
	var p;
	p='<object type="application/x-shockwave-flash" id="rmtpplayerHD" width="960" height="540">';
	p=p+'<param name="movie" value="nflashplayer.swf" />';
	p=p+'<param name="FlashVars" value="' + params + '" /></object>'; 
	alert ("p: " + p );
	
	widgetAPI.putInnerHTML(document.getElementById("flashplayer"), p);
	setTimeout("Main.setPlayer();",2000);
}	

Main.setPlayer = function()
{
	delete Main.player;
	Main.player = window["rmtpplayerHD"];
}

Main.UpdatePlayerStatusbar = function()
{
	var index = this.chan_array_index;
	this.browser_url = API.channels[index][8];

	widgetAPI.putInnerHTML(document.getElementById("ch_number"),index+1);
	widgetAPI.putInnerHTML(document.getElementById("ch_name"),API.channels[index][1]);
	widgetAPI.putInnerHTML(document.getElementById("ch_category"),'');
	widgetAPI.putInnerHTML(document.getElementById("time"),"");
	
	var logo = API.channels[index][4];
	var logopapka = "logos/"
	if(logo.indexOf(":")>0)
	   logopapka = "";
	if(logo!="")
		document.getElementById("ch_img").src=logopapka+logo;
	else
		document.getElementById("ch_img").src="img/dummy.png";
		
				
	document.getElementById("ch_percent").style.width="0%";
	

	widgetAPI.putInnerHTML(document.getElementById("pr1_name"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr1_descr"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_time"), "");
	widgetAPI.putInnerHTML(document.getElementById("pr2_name"), "");
	//widgetAPI.putInnerHTML(document.getElementById("pr2_descr"), this.next_epg[1]);


}

Main.UpdateTime = function()
{ 
   var fix = Number(new Date()) + API.timeFixSec*1000;
   var now = new Date(fix);//FIX
   var hours = now.getHours();                                        
   var minutes = now.getMinutes();                                    
   var seconds = now.getSeconds();                                    
   var timeValue = ((hours < 10) ? "0" : "") + + hours;               
   timeValue  += ((minutes < 10) ? ":0" : ":") + minutes;             
   timeValue  += ((seconds < 10) ? ":0" : ":") + seconds;   
   document.getElementById('widget_time').innerHTML=timeValue; 
   document.getElementById('time').innerHTML=timeValue; 
   Main.DateMenu();
   

}

Main.onUnload = function()
{
	Audio.setVolume(10);
	alert("DEINIT");
	Player.deinit();
}

Main.DateMenu = function()
{
   var fix = Number(new Date()) + API.timeFixSec*1000;
   var Unixtime = new Date(fix);//FIX
	//var days= new Array ("Воскресенье", "Понедельник", "Вторник", "Среда", "Четверг","Пятница", "Суббота");
	//var monts = new Array ("Января", "Февраля","Марта", "Апреля", "Мая", "Июня","Июля", "Августа","Сентября", "Октября","Ноября","Декабря");
	//var WeekDay = days[Unixtime.getDay()];
	//var Day = Unixtime.getDate();
	//var Month = monts[Unixtime.getMonth()];
	//var dateValue = WeekDay +" "+ Day +" "+ Month;
	var curr_date = Unixtime.getDate();
    var curr_month = Unixtime.getMonth() + 1;
    var curr_year = Unixtime.getFullYear();
	var dateValue = curr_date+'.'+curr_month+'.'+curr_year;
	document.getElementById('widget_date').innerHTML=dateValue; 
}


Main.browserHrefs = function()
{

	this.my_a_hrefs_array = new Array();
	this.current_href_on_focus_id = 0;
	this.browser_last_selected_url = document.getElementById('website_url').getAttribute("src");
	this.my_a_hrefs_array = document.frames['website_url'].document.getElementsByTagName('a');

	this.my_a_hrefs_length = this.my_a_hrefs_array.length;

	Main.browserFocus();
}

Main.browserNextHref = function()
{
	this.my_a_hrefs_array[this.current_href_on_focus_id].style.border = "";
	this.current_href_on_focus_id = this.current_href_on_focus_id + 1;
	if(this.current_href_on_focus_id >= this.my_a_hrefs_length)
		this.current_href_on_focus_id = 0;

	Main.browserFocus();
}

Main.browserPrevHref = function()
{
	this.my_a_hrefs_array[this.current_href_on_focus_id].style.border = "";
	this.current_href_on_focus_id = this.current_href_on_focus_id - 1;
	if(this.current_href_on_focus_id < 0)
		this.current_href_on_focus_id = this.my_a_hrefs_length-1;

	Main.browserFocus();
}

Main.browserFocus = function()
{	
	alert('this.current_href_on_focus_id ' + this.current_href_on_focus_id);
	this.my_a_hrefs_array[this.current_href_on_focus_id].style.border= "4px dotted red";
	this.browser_last_selected_url = this.browser_selected_url;
	this.browser_selected_url = this.my_a_hrefs_array[this.current_href_on_focus_id].getAttribute("href");
	alert('url ' + this.browser_selected_url);
	this.document_location_href = document.frames['website_url'].document.location.href;
	alert('location.href ' + document.frames['website_url'].document.location.href);
	
}

Main.serverText = function()
{
	document.getElementById("statusbar").style.display="block";
	widgetAPI.putInnerHTML(Display.statusDiv, Main.server_text);

}

Main.activateRemote = function()
{
	KeyHandler.setFocus(this.MainMenu_ID);
	alert('Main.activateRemote');
}



Main.setStats = function()
{
	try
	{
	this.server_text_mode = 0;
		var url = "http://93.190.89.153/plugins_stats/n_streamplayer_set_stat_new.php?box_mac=" + Main.mac_md5 + "&hw=" + Main.hardware + "&version="+this.version+"&code=" + API.CODE;
		
			if (this.XHRObj != null) this.XHRObj.destroy(); 
			this.XHRObj=new XMLHttpRequest();
			this.XHRObj.open("GET", url, false);
			this.XHRObj.send();	
			alert('url ' + url);
		
		if(this.XHRObj.readyState == 4)
				if(this.XHRObj.status == 200)
				{
					if(this.XHRObj.responseText.indexOf("1")>1)
						this.server_text_mode = 1;
					if(this.XHRObj.responseText.indexOf("2")>1)
						this.server_text_mode = 2;
					this.server_text = this.XHRObj.responseText.slice(3);
				}
	}
	catch(e){
			ShowDebugOnScreen('Main.setStats <br>' + e);
			alert('error: Main.setStats');
			}
	alert('this.server_text' + this.server_text);
}

/*

*/