﻿var API =
{
	XML_URL_1 : 'http//portal.nstreamvod.profiservice.ws',
	XML_URL_2 : 'nStreamExternal.xml',
	XML_URL_3 : 'nStreamTVplaylist.xml',
	XML_URL_4 : 'nStreamVODplaylist.xml',
	XML_URL_5 : 'nStream.xml',
	CODE : '',
	channels : [ ],
	all_channels : [ ],
	chan_counter: 0,
	chan_pages : 0,
	last_page_channels_counter : 0,
	XHRObj : null,
	server_text : '',
	categories : [ ],
	timeFix : 0,
	timeFixSec : 0,
	server_text_mode : 0,
	yandex_days : 0,
	active_url : null,
	PlaylistArray : [ ],
	search_string : '',
	request_error : false,
	loading : false,
	prev_page_url : '',
	next_page_url : '',
	search_on : '',
	send_mac : true,
}

API.init = function()
{

	var setupArray=new Array();
	try
	{

		var fileSystemObj = new FileSystem();
		var oFile=fileSystemObj.openCommonFile("nstreamvod.dat", "r");

		if (oFile)
		{
			while(1)
			{
				l= oFile.readLine();
				if (l==null) 
					break;
				setupArray.push(l);
			 }
			fileSystemObj.closeCommonFile(oFile);
			if(setupArray[0] && setupArray[0].length>5)
				this.XML_URL_1 = setupArray[0];
			if(setupArray[1] && setupArray[1].length>5)
				this.XML_URL_2 = setupArray[1];
			if(setupArray[2] && setupArray[2].length>5)
				this.XML_URL_3 = setupArray[2];
			if(setupArray[3] && setupArray[3].length>5)
				this.XML_URL_4 = setupArray[3];
			if(setupArray[4] && setupArray[4].length>5)
				this.XML_URL_5 = setupArray[4];
			if(setupArray[5] && setupArray[5].length>5)
				this.CODE = setupArray[5];
			if (setupArray[6])
				this.timeFix = parseInt(setupArray[6]);
		}
	}
	catch(e){
		ShowDebugOnScreen('API.init' + e);
		alert('API.init ERROR' + e);
	}

	this.PlaylistArray.push( new Array(API.XML_URL_1, API.XML_URL_1));			
	this.PlaylistArray.push( new Array(API.XML_URL_2, API.XML_URL_2));	
	this.PlaylistArray.push( new Array(API.XML_URL_3, API.XML_URL_3));	
	this.PlaylistArray.push( new Array(API.XML_URL_4, API.XML_URL_4));	
	this.PlaylistArray.push( new Array(API.XML_URL_5, API.XML_URL_5));	

	var tm = new Date();
	this.timeFixSec = this.timeFix*60*60;
	API.todayDay();
	this.active_url = this.XML_URL_1;
	return true
}

API.todayDay = function()
{
	var minutes=1000*60;
	var hours=minutes*60;
	var days=hours*24;
	var t=Number(new Date());
	var days=t/days;
	this.yandex_days = parseInt(days+'');
}

API.Request = function(xml_url)
{
	Main.selected_channel = 0;
	Main.selected_page = 0;
	Main.chan_array_index = 0;
	this.request_error = false;
	try
	{

		if(this.send_mac)
		{
			alert('MAC_' + Main.md5_clear);
			alert('this.search_string_' + this.search_string);
			alert('API.search_on_' + this.search_on);
			if(this.search_string!="" && API.search_on !="")
			{
				var sign = "?";
				if(this.active_url.indexOf("?")>1)
					sign = '&';
				xml_url = xml_url + sign + API.search_on + '=' + this.search_string + '&box_mac=' + Main.mac_md5;
			}
			else
			{
				var sign = "?";
				if(this.active_url.indexOf("?")>1)
					sign = '&';
				xml_url = xml_url + sign + 'box_mac=' + Main.mac_md5;
			}
		}
		this.send_mac = true;
		/**/
		alert('+++++++++ xml_url ' + xml_url);
		if (this.XHRObj != null) 
			this.XHRObj.destroy();

		this.XHRObj = new XMLHttpRequest();
		
		this.XHRObj.open("GET", xml_url, false);

		this.XHRObj.send(null);
		this.search_string = "";	
		if(this.XHRObj.readyState == 4)
			if(this.XHRObj.status == 200)
			{
				if(this.active_url.indexOf(".m3u")>1)
					var xmlDoc = this.XHRObj.responseText;
				else
					var xmlDoc = this.XHRObj.responseXML;
				//alert('lllllllllllllllll' + this.XHRObj.responseText);
				return xmlDoc;
			}
		
		Display.status("REQUEST ERROR 1");
		this.request_error = true;
		return true;
		
	} catch(e){
		Display.status("REQUEST ERROR 2");
		alert('ALERT 122: ' + e);
		this.request_error = true;
		return true;
		//ShowDebugOnScreen('API.Request <br>' + e);
		
	}
}

API.showLoading = function()
{
	if(this.loading)
	{
	document.getElementById("statusbar").style.display="block";
    widgetAPI.putInnerHTML(document.getElementById("status"), 'LOADING');
	document.getElementById('widget_time').innerHTML='LOADING'; 
	}
	//alert('API.showLoading');
	//setTimeout("API.showLoading();",200)
}

API.getChannel_list = function()
{
	
	this.prev_page_url = '';
	this.next_page_url = '';
	this.loading = true;
	try
	{

		var xmlChannels = API.Request(this.active_url);
		if(this.request_error == true)
			return false;
		this.chan_counter = 0;
		this.categories  = new Array();
		this.channels = new Array();
	
		if(this.active_url.indexOf(".m3u")>1)
		{
			var m3u_array = xmlChannels.split('\n');
			for (var index = 0; index < m3u_array.length; index++)
			{
				if(m3u_array[index].indexOf("PLAYLIST NAME")>-1)
				{
					index = index + 1;
					widgetAPI.putInnerHTML(document.getElementById("playlist_name"), m3u_array[index]);
				}
				if(m3u_array[index].indexOf("#EXTINF")>-1 && m3u_array[index+1].indexOf("://")>-1)
				{
					this.chan_counter = this.chan_counter + 1;
					var name = m3u_array[index].substr(m3u_array[index].indexOf(' '));
					var url = m3u_array[index+1].replace(/^\s*/, "").replace(/\s*$/, "");
					video_type = API.getStreamType(url);
					//alert('VT: ' + video_type);
					var Channel = Array(this.chan_counter, name, url, video_type, '', '', url, '', '', '');
					//alert('Channel ' + Channel);
					this.channels.push(Channel);	
					index = index + 1;
				}
			}
			API.countPages();
		}
		else if(xmlChannels)
		{
		
			
			widgetAPI.putInnerHTML(document.getElementById("playlist_name"), "NO TITLE");
			document.getElementById("page_plus").style.display="none";
			document.getElementById("page_minus").style.display="none";
			document.getElementById("search_on").style.display="none";
			widgetAPI.putInnerHTML(document.getElementById("page_minus_text"), "Prev.Page");
			widgetAPI.putInnerHTML(document.getElementById("page_plus_text"), "Next.Page");
			widgetAPI.putInnerHTML(document.getElementById("search_on_text"), "Search");
				
				
			try
			{
				var playlist_name = xmlChannels.getElementsByTagName("playlist_name")
				this.playlist_name = playlist_name[0].childNodes[0].nodeValue;
				widgetAPI.putInnerHTML(document.getElementById("playlist_name"), this.playlist_name);
			} catch(e){
			//alert('url not found');
			}

			
			try
			{
				var prev_page_url = xmlChannels.getElementsByTagName("prev_page_url");
				this.prev_page_url = prev_page_url[0].childNodes[0].nodeValue;
				document.getElementById("page_plus").style.display="block";
				var text = prev_page_url[0].getAttribute("text");
				if(text)
					widgetAPI.putInnerHTML(document.getElementById("page_plus_text"), text);
			} catch(e){
			//alert('url not found');
			}
	
			try
			{			
				var next_page_url = xmlChannels.getElementsByTagName("next_page_url");
				this.next_page_url = next_page_url[0].childNodes[0].nodeValue;
				document.getElementById("page_minus").style.display="block";
				var text = next_page_url[0].getAttribute("text");
				if(text)
					widgetAPI.putInnerHTML(document.getElementById("page_minus_text"), text);
			} catch(e){
			//alert('url not found');
			}

				
			try
			{
				var search_on = xmlChannels.getElementsByTagName("search_on");
				this.search_on = search_on[0].childNodes[0].nodeValue;
				document.getElementById("search_on").style.display="block";
				var text = search_on[0].getAttribute("text");
				if(text)
					widgetAPI.putInnerHTML(document.getElementById("search_on_text"), text);				
			} catch(e){
			//alert('url not found');
			}					
alert('üüüüüüüüüüüüüüüüüüüüüü' + this.search_on);

			//alert('items.length ' + items.length);
			
			var items = xmlChannels.getElementsByTagName("channel");
			
			for (var index = 0; index < items.length; index++)
			{
				this.chan_counter = this.chan_counter + 1;
				var title = "";
				try
				{
				title = items[index].getElementsByTagName("title")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('title not found');
				}
				
				var url = "";
				try
				{			
				url = items[index].getElementsByTagName("stream_url")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('url not found');
				}
				
				var video_type = "";

				try
				{			
					video_type = items[index].getElementsByTagName("video_type")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('video_type not found');
					video_type = API.getStreamType(url);	
				}		
				var logo_30x30 = "";			
				try
				{	
					logo_30x30 = items[index].getElementsByTagName("logo_30x30")[0].childNodes[0].nodeValue;
				} catch(e){
					//alert('logo_30x30 not found');
				}
				/*
				try
				{			
				var buffer_byte = "";
				buffer_byte = items[index].getElementsByTagName("buffer_byte")[0].childNodes[0].nodeValue;
				} catch(e){
				alert('buffer_byte not found');
				}
				*/
				
				var description = "";
				try
				{			
				description = items[index].getElementsByTagName("description")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('description not found');
				}

				var category = "";
				try
				{			
				category = items[index].getElementsByTagName("category_id")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('category not found');
				}

				var browser_url = "";
				try
				{			
				browser_url = items[index].getElementsByTagName("browser_url")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('browser_url not found');
				}
				
				var playlist_url = "";
				try
				{			
				playlist_url = items[index].getElementsByTagName("playlist_url")[0].childNodes[0].nodeValue;
				} catch(e){
				//alert('playlist_url not found');
				}

				var Channel = Array(this.chan_counter, title, url, video_type, logo_30x30, '', description, category, browser_url, playlist_url);
				
				//alert('Channel ' + Channel);

				this.channels.push(Channel);
			}

			this.all_channels = this.channels;
			API.countPages();
			

			this.categories.push(Array('','ALL'));
			try
			{
				var category_items = xmlChannels.getElementsByTagName("category");
				
				
				//alert('categories.length ' + category_items.length);
				for (var index = 0; index < category_items.length; index++)
				{		
					var cat_id = "";
					try
					{
						cat_id = category_items[index].getElementsByTagName("category_id")[0].childNodes[0].nodeValue;
					} catch(e){
						//alert('category_id not found');
					}
					
					var cat_name = "";
					try
					{			
						cat_name = category_items[index].getElementsByTagName("category_title")[0].childNodes[0].nodeValue;
					} catch(e){
						//alert('category_title not found');
					}	
					var Category = new Array(cat_id, cat_name);
					this.categories.push(Category);
				}
				//alert('categorie ' + this.categories);
			} catch(e){
				//alert('category array not found');
			}
			//alert('this.categories ' + this.categories);
			
			//alert('this.channels ' + this.channels);
			if(this.chan_counter>0)
			{
				Display.hidestatus();
				this.loading = false;
				return true;
			}
			else
			{
				Display.status("CHANNEL LIST ERROR 1");
				return false;
			}		
		}
		else
		{
		document.getElementById("statusbar").style.display="block";
		widgetAPI.putInnerHTML(Display.statusDiv, '<b style="color:red">BAD URL or PLAYLIST ERROR</b>');
		}
	} catch(e){
		//ShowDebugOnScreen('API.getChannel_list <br>' + e);
		Display.status("CHANNEL LIST ERROR 2");
		alert('ALERT 2: ' + e);
		return false
	}

}

API.getStreamType = function(url)
{	
	type = "http";	
	
	if(url.indexOf("rtmp")>-1)
		type = "rtmp";
	//if(url.indexOf("flv")>-1)
		//type = "flv";
	if(url.indexOf("m3u8")>-1)
		type = "hls";
			
	return type

}

API.setCategory = function(cat_id)
{
	this.channels = Array();
	if(cat_id=="")
		API.getChannel_list();
	else
	{	
		this.chan_counter = 0;
		Main.selected_channel = 0;
		Main.selected_page = 0;
		Main.chan_array_index = 0;
		for (var index = 0; index < this.all_channels.length; index++)
		{	
			if(this.all_channels[index][7]==cat_id)
				this.channels.push(this.all_channels[index]);
		}
		API.countPages();
	}
}

API.countPages = function()
{
	this.chan_counter = this.channels.length;

	this.chan_pages = this.chan_counter;
	this.last_page_channels_counter = this.chan_counter % 10;
	if(this.last_page_channels_counter==0)
		this.last_page_channels_counter = 10;
	
	if ( this.last_page_channels_counter > 0 && this.last_page_channels_counter < 5)
		this.chan_pages = Math.round(this.chan_pages / 10) + 1;
	else
		this.chan_pages = Math.round(this.chan_pages / 10);
		
	//alert('chan_pages '+this.chan_pages);
	//alert('last_page_channels_counter '+this.last_page_channels_counter);
	//alert('chan_counter '+this.chan_counter);
}

API.IndexOfId = function(myarray, id)
{
	for (var index = 0; index < myarray.length; index++)
	{
		if(parseInt(myarray[index])==parseInt(id))
			return index
	}
	return -1
}