﻿var Selectbox =
{
	html : null,
	selected : 0,
	length : 0,
	select_list : [ ],
	selectbox_html : null,
	title : null,
	selected_page : 0,
	pages : 0,
	last_page_counter : 0,
	mode : 0,
}

Selectbox.setBox = function(title, select_list)
{
	try
	{	
		this.selected = 0;
		this.title = title;
		this.select_list = select_list;
		this.length = select_list.length;
		this.selectbox_html = document.getElementById("selectbox");
		this.selectbox_html.style.display="";

		this.last_page_counter = this.length % 11;
		if(this.last_page_counter==0)
			this.last_page_counter = 11;
		
		if ( this.last_page_counter > 0 && this.last_page_counter < 5)
			this.pages = Math.round(this.length / 11) + 1;
		else
			this.pages = Math.round(this.length / 11);
		
		Selectbox.updateBox();
	
	} catch(e){
		ConsoleLog("setBox ERROR: "+e);
	}
}

Selectbox.updateBox = function()
{

	try
	{

			
		var item_on_page = 11;
		
		if(this.selected_page > this.pages-1)
			this.selected_page = 0;
			
		if(this.selected_page < 0)
			this.selected_page = this.pages-1;

		if(this.selected_page == this.pages-1)
		{
			item_on_page = this.last_page_counter;
			if(this.selected > this.last_page_counter-1)
				this.selected = this.last_page_counter-1;
		}
		//NEW FIX
		
		if(this.selected_page<0 || (this.selected_page == this.pages))
		{
			if(this.selected_page<0)
				this.selected_page=0;
			item_on_page = this.last_page_counter;
			if(this.selected > this.last_page_counter-1)
					this.selected = 0;
			if(this.selected < 0)
					this.selected = this.last_page_counter-1;
			alert('this.selected ' + this.selected);
		}
		this.html= '<div><div style="text-align:center;width:100%;"><b>' + this.title + '</b></div><br><ul>';
		
		for (var index = 0; index < item_on_page; index++)
		{
			var array_index = 11*this.selected_page + index;
			var style="";
			if(index == this.selected)
				style='style="color:#ffffff; border: 1px solid #ffffff" ';
			 alert('array_index ' + array_index);
			if(this.select_list[array_index][1])
				this.html+= '<li ' +style+ '>' + this.select_list[array_index][1] + '</li>';
			else
				{
				var episode = array_index + 1;
				this.html+= '<li>' + episode + ' СЕРИЯ</li>';
				}
		}
		var help_html = '<div><div id="navi_button"><img src="img/buttons/back.png"></img></div><span id="navi_helpertext">EXIT</span>';
		help_html+=	'<div id="navi_button"><img src="img/buttons/move.png"></img></div><span id="navi_helpertext">MOVE</span>';
		help_html+=	'<div id="navi_button"><img src="img/buttons/enter.png"></img></div><span id="navi_helpertext">ОК</span></div>';
		
		this.html+='</ul>'+help_html+'</div>';

		widgetAPI.putInnerHTML(this.selectbox_html, this.html);
		
	} catch(e){
		ConsoleLog("updateBox ERROR: "+e);
	}

}

Selectbox.selectNextItem = function()
{
	this.selected++;

	if(this.selected>=11 || (this.selected_page == this.pages-1 && this.selected==this.last_page_counter))
	{
		this.selected = 0;
		this.selected_page++;
	}
	Selectbox.updateBox();	
}
		
Selectbox.selectPrevItem = function()
{
	this.selected--;
	
	if(this.selected_page == 0 && this.selected_channel<0)
	{
		this.selected = this.last_page_counter - 1;
		this.selected_page = this.pages-1;
	}
	
	if(this.selected<0)
	{
		this.selected = 10;
		this.selected_page--;
		
	}
	Selectbox.updateBox();
}

Selectbox.selectNextPage = function()
{
	this.selected_page++;
	Selectbox.updateBox();
}

Selectbox.selectPrevPage = function()
{
	this.selected_page--;
	Selectbox.updateBox();
}

Selectbox.SelectCategory = function()
{
	var cat_id = this.select_list[11*this.selected_page + this.selected][0];
	this.selectbox_html.style.display="none";
	API.setCategory(cat_id);
	KeyHandler.setFocus(Main.MainMenu_ID);
	Main.Menu();

}

Selectbox.SelectPlaylist = function()
{
	API.active_url = this.select_list[11*this.selected_page + this.selected][0];
	this.selectbox_html.style.display="none";
	API.getChannel_list();
	KeyHandler.setFocus(Main.MainMenu_ID);
	Main.Menu();

}